/***************************************************************************
                          toyparse_internal.h

    Internal function definitions used only in the Toy Memory String Parser.
                             -------------------
    begin                : Sat Jan 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    student #            : 200200370
    class                : CS330
    email                : tsm@accesscomm.ca 
***************************************************************************/

#ifndef __TOYPARSE_INTERNAL_H__
#define __TOYPARSE_INTERNAL_H__

#ifdef __cplusplus
  extern "C" {
#endif/*__cplusplus*/

#include <SDL/begin_code.h>

/*! \brief Converts a list of string-tokens to an array of types */
DECLSPEC TokenType *SDLCALL TokensToType(const char **tokens, const char **table[]);

/*! \brief Finds specified string in a table of strings.*/
/**  Returns
 * the index found at on success, or -1 on error.
 */
DECLSPEC int SDLCALL FindInList(const char *str, const char *list[]);

/*! \brief Compares a word with a syntax-string to see if it matches the specified syntax. */
DECLSPEC int SDLCALL CompareType(const char *str, const char *typestr);

DECLSPEC char **SDLCALL Explode(const char *str);
DECLSPEC void SDLCALL FreeStrList(char **str);

#include <SDL/close_code.h>

#ifdef __cplusplus
  }
#endif/*__cplusplus*/

#endif/*__TOYPARSE_INTERNAL_H__*/
